# Class AbstractResult

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
AbstractResult

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Result`

Direct Known Subclasses:
  `DefaultConformanceResult`, `DefaultCoverageResult`, `DefaultDescriptiveResult`, `DefaultQuantitativeResult`

public class AbstractResult extends ISOMetadata implements Result
Base class of more specific result classes.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractResult()`
  Constructs an initially empty result.
  `AbstractResult(Result object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static AbstractResult`
  `castOrCopy(Result object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Temporal`
  `getDateTime()`
  Returns the date when the result was generated.
  `Scope`
  `getResultScope()`
  Returns the scope of the result.
  `MetadataStandard`
  `getStandard()`
  Returns the metadata standard, which is ISO 19157.
  `void`
  `setDateTime(Temporal newValue)`
  Sets the date when the result was generated.
  `void`
  `setResultScope(Scope newValue)`
  Sets the scope of the result.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, setIdentifier`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, clone, equals, equals, getInterface, hashCode, isEmpty, nilReasons, prune, toString`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AbstractResult

    public AbstractResult()
    Constructs an initially empty result.

  - ### AbstractResult

    public AbstractResult(Result object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(Result)`

- ## Method Details

  - ### castOrCopy

    public static AbstractResult castOrCopy(Result object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is an instance of `ConformanceResult`, `QuantitativeResult` or `CoverageResult`, then this method delegates to the `castOrCopy(…)` method of the corresponding SIS subclass. Note that if the given object implements more than one of the above-cited interfaces, then the `castOrCopy(…)` method to be used is unspecified.
    - Otherwise if the given object is already an instance of `AbstractResult`, then it is returned unchanged.
    - Otherwise a new `AbstractResult` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getResultScope

    @UML(identifier="resultScope", obligation=OPTIONAL, specification=UNSPECIFIED) public Scope getResultScope()
    Returns the scope of the result.
    Returns:
      scope of the result, or `null` if unspecified.
    Since:
      1.3

  - ### setResultScope

    public void setResultScope(Scope newValue)
    Sets the scope of the result.
    Parameters:
      `newValue` - the new evaluation procedure.
    Since:
      1.3

  - ### getDateTime

    @UML(identifier="dateTime", obligation=OPTIONAL, specification=UNSPECIFIED) public Temporal getDateTime()
    Returns the date when the result was generated. The specified value should be an instance of `LocalDate`, `LocalDateTime`, `OffsetDateTime` or `ZonedDateTime`, depending whether hours are defined and how the timezone (if any) is defined. But other types are also allowed.
    Returns:
      date of the result, or `null` if none.
    Since:
      1.3

  - ### setDateTime

    public void setDateTime(Temporal newValue)
    Sets the date when the result was generated.
    Parameters:
      `newValue` - the new date, or `null`.
    Since:
      1.3

  - ### getStandard

    public MetadataStandard getStandard()
    Returns the metadata standard, which is ISO 19157.
    Overrides:
      `getStandard` in class `ISOMetadata`
    Returns:
      the metadata standard, which is ISO 19157.